"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApisInstance = require("./ApisInstance");

var ApisSingleton = function () {
	function ApisSingleton() {
		_classCallCheck(this, ApisSingleton);

		this.inst = null;
	}

	_createClass(ApisSingleton, [{
		key: "setRpcConnectionStatusCallback",
		value: function setRpcConnectionStatusCallback(callback) {
			this.statusCb = callback;
			if (this.inst) this.inst.setRpcConnectionStatusCallback(callback);
		}

		/**
   @arg {string} cs is only provided in the first call
   @return {Apis} singleton .. Check Apis.instance().init_promise to know when the connection is established
   */

	}, {
		key: "reset",
		value: function reset() {
			var cs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "ws://localhost:8090";
			var connect = arguments[1];
			var user = arguments[2];
			var passowrd = arguments[3];

			if (this.inst) {
				this.inst.close();
				this.inst = null;
			}
			this.inst = new ApisInstance();
			this.inst.setRpcConnectionStatusCallback(this.statusCb);

			if (this.inst && connect) {
				this.inst.connect(cs, user, passowrd);
			}

			return this.inst;
		}
	}, {
		key: "instance",
		value: function instance() {
			var cs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "ws://localhost:8090";
			var connect = arguments[1];
			var user = arguments[2];
			var passowrd = arguments[3];

			if (!this.inst) {
				this.inst = new ApisInstance();
				this.inst.setRpcConnectionStatusCallback(this.statusCb);
			}

			if (this.inst && connect) {
				this.inst.connect(cs, user, passowrd);
			}

			return this.inst;
		}
	}, {
		key: "close",
		value: function close() {
			if (this.inst) {
				this.inst.close();
				this.inst = null;
			}
		}
	}]);

	return ApisSingleton;
}();

exports.default = ApisSingleton;